/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.core.engine.whatif;

import java.util.Iterator;

import tools.descartes.dql.models.mapping.domain.Entity;
import tools.descartes.dql.models.mapping.domain.Probe;
import tools.descartes.dql.models.mapping.mapping.EntityMapping;

public class MetricFilter implements WhatIfFilter {

	private String metricIdentifier;

	public MetricFilter(String metricIdentifier) {
		this.metricIdentifier = metricIdentifier;
	}

	@Override
	public EntityMapping applyFilter(EntityMapping initial, EntityMapping modified) {
		for (Iterator<Entity> i = modified.getEntities().iterator(); i.hasNext();) {
			Entity r = i.next();
			for (Iterator<Probe> i2 = r.getProbes().iterator(); i2.hasNext();) {
				Probe probe = i2.next();
				if (!probe.getMetricName().equals(metricIdentifier)) {
					i2.remove();
				}
			}
			if (r.getProbes().isEmpty())
				i.remove();
		}

		return modified;

	}

}
