/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL;

import org.eclipse.emf.ecore.EObject;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Aggregate Metric Clause</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.AggregateMetricClause#getFunction <em>Function</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.AggregateMetricClause#getMetrics <em>Metrics</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.AggregateMetricClause#getProperties <em>Properties</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getAggregateMetricClause()
 * @model
 * @generated
 */
public interface AggregateMetricClause extends MetricClauseType
{
  /**
   * Returns the value of the '<em><b>Function</b></em>' attribute.
   * The literals are from the enumeration {@link tools.descartes.dql.lang.descartesQL.StatisticalAggregateType}.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Function</em>' attribute isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Function</em>' attribute.
   * @see tools.descartes.dql.lang.descartesQL.StatisticalAggregateType
   * @see #setFunction(StatisticalAggregateType)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getAggregateMetricClause_Function()
   * @model
   * @generated
   */
  StatisticalAggregateType getFunction();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.AggregateMetricClause#getFunction <em>Function</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Function</em>' attribute.
   * @see tools.descartes.dql.lang.descartesQL.StatisticalAggregateType
   * @see #getFunction()
   * @generated
   */
  void setFunction(StatisticalAggregateType value);

  /**
   * Returns the value of the '<em><b>Metrics</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Metrics</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Metrics</em>' containment reference.
   * @see #setMetrics(EObject)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getAggregateMetricClause_Metrics()
   * @model containment="true"
   * @generated
   */
  EObject getMetrics();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.AggregateMetricClause#getMetrics <em>Metrics</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Metrics</em>' containment reference.
   * @see #getMetrics()
   * @generated
   */
  void setMetrics(EObject value);

  /**
   * Returns the value of the '<em><b>Properties</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Properties</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Properties</em>' containment reference.
   * @see #setProperties(ConfigurationPropertiesClause)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getAggregateMetricClause_Properties()
   * @model containment="true"
   * @generated
   */
  ConfigurationPropertiesClause getProperties();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.AggregateMetricClause#getProperties <em>Properties</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Properties</em>' containment reference.
   * @see #getProperties()
   * @generated
   */
  void setProperties(ConfigurationPropertiesClause value);

} // AggregateMetricClause
