/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL;


/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Select Query</b></em>'.
 * <!-- end-user-doc -->
 *
 * <p>
 * The following features are supported:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.SelectQuery#getMetricReferenceClauses <em>Metric Reference Clauses</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.SelectQuery#getConstraintClause <em>Constraint Clause</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.SelectQuery#getDofClause <em>Dof Clause</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.SelectQuery#getForClause <em>For Clause</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.SelectQuery#getUsingClause <em>Using Clause</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.SelectQuery#getObserveClause <em>Observe Clause</em>}</li>
 * </ul>
 *
 * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getSelectQuery()
 * @model
 * @generated
 */
public interface SelectQuery extends PerformanceMetricsQuery
{
  /**
   * Returns the value of the '<em><b>Metric Reference Clauses</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Metric Reference Clauses</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Metric Reference Clauses</em>' containment reference.
   * @see #setMetricReferenceClauses(MetricReferenceClauses)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getSelectQuery_MetricReferenceClauses()
   * @model containment="true"
   * @generated
   */
  MetricReferenceClauses getMetricReferenceClauses();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.SelectQuery#getMetricReferenceClauses <em>Metric Reference Clauses</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Metric Reference Clauses</em>' containment reference.
   * @see #getMetricReferenceClauses()
   * @generated
   */
  void setMetricReferenceClauses(MetricReferenceClauses value);

  /**
   * Returns the value of the '<em><b>Constraint Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Constraint Clause</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Constraint Clause</em>' containment reference.
   * @see #setConstraintClause(ConstraintClause)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getSelectQuery_ConstraintClause()
   * @model containment="true"
   * @generated
   */
  ConstraintClause getConstraintClause();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.SelectQuery#getConstraintClause <em>Constraint Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Constraint Clause</em>' containment reference.
   * @see #getConstraintClause()
   * @generated
   */
  void setConstraintClause(ConstraintClause value);

  /**
   * Returns the value of the '<em><b>Dof Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Dof Clause</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Dof Clause</em>' containment reference.
   * @see #setDofClause(DoFClause)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getSelectQuery_DofClause()
   * @model containment="true"
   * @generated
   */
  DoFClause getDofClause();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.SelectQuery#getDofClause <em>Dof Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Dof Clause</em>' containment reference.
   * @see #getDofClause()
   * @generated
   */
  void setDofClause(DoFClause value);

  /**
   * Returns the value of the '<em><b>For Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>For Clause</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>For Clause</em>' containment reference.
   * @see #setForClause(ForClause)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getSelectQuery_ForClause()
   * @model containment="true"
   * @generated
   */
  ForClause getForClause();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.SelectQuery#getForClause <em>For Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>For Clause</em>' containment reference.
   * @see #getForClause()
   * @generated
   */
  void setForClause(ForClause value);

  /**
   * Returns the value of the '<em><b>Using Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Using Clause</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Using Clause</em>' containment reference.
   * @see #setUsingClause(UsingClause)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getSelectQuery_UsingClause()
   * @model containment="true"
   * @generated
   */
  UsingClause getUsingClause();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.SelectQuery#getUsingClause <em>Using Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Using Clause</em>' containment reference.
   * @see #getUsingClause()
   * @generated
   */
  void setUsingClause(UsingClause value);

  /**
   * Returns the value of the '<em><b>Observe Clause</b></em>' containment reference.
   * <!-- begin-user-doc -->
   * <p>
   * If the meaning of the '<em>Observe Clause</em>' containment reference isn't clear,
   * there really should be more of a description here...
   * </p>
   * <!-- end-user-doc -->
   * @return the value of the '<em>Observe Clause</em>' containment reference.
   * @see #setObserveClause(ObserveClause)
   * @see tools.descartes.dql.lang.descartesQL.DescartesQLPackage#getSelectQuery_ObserveClause()
   * @model containment="true"
   * @generated
   */
  ObserveClause getObserveClause();

  /**
   * Sets the value of the '{@link tools.descartes.dql.lang.descartesQL.SelectQuery#getObserveClause <em>Observe Clause</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @param value the new value of the '<em>Observe Clause</em>' containment reference.
   * @see #getObserveClause()
   * @generated
   */
  void setObserveClause(ObserveClause value);

} // SelectQuery
