/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import tools.descartes.dql.lang.descartesQL.AggregateMetricClause;
import tools.descartes.dql.lang.descartesQL.ConfigurationPropertiesClause;
import tools.descartes.dql.lang.descartesQL.DescartesQLPackage;
import tools.descartes.dql.lang.descartesQL.StatisticalAggregateType;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Aggregate Metric Clause</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.AggregateMetricClauseImpl#getFunction <em>Function</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.AggregateMetricClauseImpl#getMetrics <em>Metrics</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.AggregateMetricClauseImpl#getProperties <em>Properties</em>}</li>
 * </ul>
 *
 * @generated
 */
public class AggregateMetricClauseImpl extends MetricClauseTypeImpl implements AggregateMetricClause
{
  /**
   * The default value of the '{@link #getFunction() <em>Function</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFunction()
   * @generated
   * @ordered
   */
  protected static final StatisticalAggregateType FUNCTION_EDEFAULT = StatisticalAggregateType.MIN;

  /**
   * The cached value of the '{@link #getFunction() <em>Function</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getFunction()
   * @generated
   * @ordered
   */
  protected StatisticalAggregateType function = FUNCTION_EDEFAULT;

  /**
   * The cached value of the '{@link #getMetrics() <em>Metrics</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMetrics()
   * @generated
   * @ordered
   */
  protected EObject metrics;

  /**
   * The cached value of the '{@link #getProperties() <em>Properties</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getProperties()
   * @generated
   * @ordered
   */
  protected ConfigurationPropertiesClause properties;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected AggregateMetricClauseImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return DescartesQLPackage.Literals.AGGREGATE_METRIC_CLAUSE;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public StatisticalAggregateType getFunction()
  {
    return function;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setFunction(StatisticalAggregateType newFunction)
  {
    StatisticalAggregateType oldFunction = function;
    function = newFunction == null ? FUNCTION_EDEFAULT : newFunction;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.AGGREGATE_METRIC_CLAUSE__FUNCTION, oldFunction, function));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EObject getMetrics()
  {
    return metrics;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetMetrics(EObject newMetrics, NotificationChain msgs)
  {
    EObject oldMetrics = metrics;
    metrics = newMetrics;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.AGGREGATE_METRIC_CLAUSE__METRICS, oldMetrics, newMetrics);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMetrics(EObject newMetrics)
  {
    if (newMetrics != metrics)
    {
      NotificationChain msgs = null;
      if (metrics != null)
        msgs = ((InternalEObject)metrics).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.AGGREGATE_METRIC_CLAUSE__METRICS, null, msgs);
      if (newMetrics != null)
        msgs = ((InternalEObject)newMetrics).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.AGGREGATE_METRIC_CLAUSE__METRICS, null, msgs);
      msgs = basicSetMetrics(newMetrics, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.AGGREGATE_METRIC_CLAUSE__METRICS, newMetrics, newMetrics));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ConfigurationPropertiesClause getProperties()
  {
    return properties;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetProperties(ConfigurationPropertiesClause newProperties, NotificationChain msgs)
  {
    ConfigurationPropertiesClause oldProperties = properties;
    properties = newProperties;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.AGGREGATE_METRIC_CLAUSE__PROPERTIES, oldProperties, newProperties);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setProperties(ConfigurationPropertiesClause newProperties)
  {
    if (newProperties != properties)
    {
      NotificationChain msgs = null;
      if (properties != null)
        msgs = ((InternalEObject)properties).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.AGGREGATE_METRIC_CLAUSE__PROPERTIES, null, msgs);
      if (newProperties != null)
        msgs = ((InternalEObject)newProperties).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.AGGREGATE_METRIC_CLAUSE__PROPERTIES, null, msgs);
      msgs = basicSetProperties(newProperties, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.AGGREGATE_METRIC_CLAUSE__PROPERTIES, newProperties, newProperties));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case DescartesQLPackage.AGGREGATE_METRIC_CLAUSE__METRICS:
        return basicSetMetrics(null, msgs);
      case DescartesQLPackage.AGGREGATE_METRIC_CLAUSE__PROPERTIES:
        return basicSetProperties(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case DescartesQLPackage.AGGREGATE_METRIC_CLAUSE__FUNCTION:
        return getFunction();
      case DescartesQLPackage.AGGREGATE_METRIC_CLAUSE__METRICS:
        return getMetrics();
      case DescartesQLPackage.AGGREGATE_METRIC_CLAUSE__PROPERTIES:
        return getProperties();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case DescartesQLPackage.AGGREGATE_METRIC_CLAUSE__FUNCTION:
        setFunction((StatisticalAggregateType)newValue);
        return;
      case DescartesQLPackage.AGGREGATE_METRIC_CLAUSE__METRICS:
        setMetrics((EObject)newValue);
        return;
      case DescartesQLPackage.AGGREGATE_METRIC_CLAUSE__PROPERTIES:
        setProperties((ConfigurationPropertiesClause)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.AGGREGATE_METRIC_CLAUSE__FUNCTION:
        setFunction(FUNCTION_EDEFAULT);
        return;
      case DescartesQLPackage.AGGREGATE_METRIC_CLAUSE__METRICS:
        setMetrics((EObject)null);
        return;
      case DescartesQLPackage.AGGREGATE_METRIC_CLAUSE__PROPERTIES:
        setProperties((ConfigurationPropertiesClause)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.AGGREGATE_METRIC_CLAUSE__FUNCTION:
        return function != FUNCTION_EDEFAULT;
      case DescartesQLPackage.AGGREGATE_METRIC_CLAUSE__METRICS:
        return metrics != null;
      case DescartesQLPackage.AGGREGATE_METRIC_CLAUSE__PROPERTIES:
        return properties != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (function: ");
    result.append(function);
    result.append(')');
    return result.toString();
  }

} //AggregateMetricClauseImpl
