/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import tools.descartes.dql.lang.descartesQL.*;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class DescartesQLFactoryImpl extends EFactoryImpl implements DescartesQLFactory
{
  /**
   * Creates the default factory implementation.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public static DescartesQLFactory init()
  {
    try
    {
      DescartesQLFactory theDescartesQLFactory = (DescartesQLFactory)EPackage.Registry.INSTANCE.getEFactory(DescartesQLPackage.eNS_URI);
      if (theDescartesQLFactory != null)
      {
        return theDescartesQLFactory;
      }
    }
    catch (Exception exception)
    {
      EcorePlugin.INSTANCE.log(exception);
    }
    return new DescartesQLFactoryImpl();
  }

  /**
   * Creates an instance of the factory.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DescartesQLFactoryImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public EObject create(EClass eClass)
  {
    switch (eClass.getClassifierID())
    {
      case DescartesQLPackage.DESCARTES_QL: return createDescartesQL();
      case DescartesQLPackage.GOAL: return createGoal();
      case DescartesQLPackage.SLA_QUERY: return createSlaQuery();
      case DescartesQLPackage.SLO_QUERY: return createSloQuery();
      case DescartesQLPackage.SLA: return createSla();
      case DescartesQLPackage.SLO: return createSlo();
      case DescartesQLPackage.WEIGHTED_SLO: return createWeightedSlo();
      case DescartesQLPackage.FUZZINESS: return createFuzziness();
      case DescartesQLPackage.PENALTY: return createPenalty();
      case DescartesQLPackage.VIOLATION: return createViolation();
      case DescartesQLPackage.MODEL_STRUCTURE_QUERY: return createModelStructureQuery();
      case DescartesQLPackage.PERFORMANCE_METRICS_QUERY: return createPerformanceMetricsQuery();
      case DescartesQLPackage.PERFORMANCE_ISSUE_QUERY: return createPerformanceIssueQuery();
      case DescartesQLPackage.CONNECTOR_CAPABILITY_QUERY: return createConnectorCapabilityQuery();
      case DescartesQLPackage.LIST_QUERY: return createListQuery();
      case DescartesQLPackage.GET_QUERY: return createGetQuery();
      case DescartesQLPackage.GET_CONSTRAINTS_QUERY: return createGetConstraintsQuery();
      case DescartesQLPackage.GET_EXPLORATION_STRATEGIES_QUERY: return createGetExplorationStrategiesQuery();
      case DescartesQLPackage.GET_TIME_UNITS_QUERY: return createGetTimeUnitsQuery();
      case DescartesQLPackage.LIST_DO_FQUERY: return createListDoFQuery();
      case DescartesQLPackage.LIST_ENTITIES_QUERY: return createListEntitiesQuery();
      case DescartesQLPackage.LIST_METRICS_QUERY: return createListMetricsQuery();
      case DescartesQLPackage.SELECT_QUERY: return createSelectQuery();
      case DescartesQLPackage.METRIC_REFERENCE_CLAUSES: return createMetricReferenceClauses();
      case DescartesQLPackage.METRIC_CLAUSE_TYPE: return createMetricClauseType();
      case DescartesQLPackage.DETECT_QUERY: return createDetectQuery();
      case DescartesQLPackage.DETECT_BOTTLENECKS_QUERY: return createDetectBottlenecksQuery();
      case DescartesQLPackage.CONSTRAINT_CLAUSE: return createConstraintClause();
      case DescartesQLPackage.DO_FCLAUSE: return createDoFClause();
      case DescartesQLPackage.EXPLORATION_STRATEGY_CLAUSE: return createExplorationStrategyClause();
      case DescartesQLPackage.CONFIGURATION_PROPERTIES_CLAUSE: return createConfigurationPropertiesClause();
      case DescartesQLPackage.CONFIGURATION_PROPERTY_CLAUSE: return createConfigurationPropertyClause();
      case DescartesQLPackage.DO_FVARIATION_CLAUSE: return createDoFVariationClause();
      case DescartesQLPackage.VALUE_VARIATION_CLAUSE: return createValueVariationClause();
      case DescartesQLPackage.INTERVAL_VARIATION_CLAUSE: return createIntervalVariationClause();
      case DescartesQLPackage.VARYING_CLAUSE: return createVaryingClause();
      case DescartesQLPackage.DO_FREFERENCE: return createDoFReference();
      case DescartesQLPackage.METRIC_CLAUSE: return createMetricClause();
      case DescartesQLPackage.AGGREGATE_METRIC_CLAUSE: return createAggregateMetricClause();
      case DescartesQLPackage.METRIC_CLAUSES: return createMetricClauses();
      case DescartesQLPackage.METRIC_STAR_CLAUSE: return createMetricStarClause();
      case DescartesQLPackage.METRIC_REFERENCE: return createMetricReference();
      case DescartesQLPackage.NAVIGATION_CLAUSE: return createNavigationClause();
      case DescartesQLPackage.CHILDREN_CLAUSE: return createChildrenClause();
      case DescartesQLPackage.PARENT_CLAUSE: return createParentClause();
      case DescartesQLPackage.FIND_CLAUSE: return createFindClause();
      case DescartesQLPackage.FOR_CLAUSE: return createForClause();
      case DescartesQLPackage.ENTITY_REFERENCE_CLAUSE: return createEntityReferenceClause();
      case DescartesQLPackage.ENTITY_REFERENCE: return createEntityReference();
      case DescartesQLPackage.ALIAS_CLAUSE: return createAliasClause();
      case DescartesQLPackage.USING_CLAUSE: return createUsingClause();
      case DescartesQLPackage.WITH_CLAUSE: return createWithClause();
      case DescartesQLPackage.MODEL_REFERENCE_CLAUSE: return createModelReferenceClause();
      case DescartesQLPackage.MODEL_FAMILY: return createModelFamily();
      case DescartesQLPackage.MODEL_LOCATION: return createModelLocation();
      case DescartesQLPackage.FILTER_CLAUSE: return createFilterClause();
      case DescartesQLPackage.FILTER_CONDITION_CLAUSE: return createFilterConditionClause();
      case DescartesQLPackage.FILTER_CONDITION_VALUE: return createFilterConditionValue();
      case DescartesQLPackage.OBSERVE_CLAUSE: return createObserveClause();
      case DescartesQLPackage.OBSERVATION_CLAUSE: return createObservationClause();
      case DescartesQLPackage.SAMPLE_CLAUSE: return createSampleClause();
      case DescartesQLPackage.CONNECTOR_TIME_UNIT_CLAUSE: return createConnectorTimeUnitClause();
      case DescartesQLPackage.CONNECTOR_INSTANCE_REFERENCE_CLAUSE: return createConnectorInstanceReferenceClause();
      case DescartesQLPackage.OBSERVE_RELATIVE_CLAUSE: return createObserveRelativeClause();
      case DescartesQLPackage.OBSERVE_BETWEEN_CLAUSE: return createObserveBetweenClause();
      case DescartesQLPackage.RELATIVE_TIME_WITH_SIGN_CLAUSE: return createRelativeTimeWithSignClause();
      case DescartesQLPackage.BETWEEN_TIME_CLAUSE: return createBetweenTimeClause();
      case DescartesQLPackage.TIME_CLAUSE: return createTimeClause();
      case DescartesQLPackage.ABSOLUTE_TIME_CLAUSE: return createAbsoluteTimeClause();
      case DescartesQLPackage.RELATIVE_TIME_CLAUSE: return createRelativeTimeClause();
      case DescartesQLPackage.RELATIVE_TIME_DURATION_CLAUSE: return createRelativeTimeDurationClause();
      case DescartesQLPackage.WHAT_IF_QUERY: return createWhatIfQuery();
      case DescartesQLPackage.WHAT_IF_VARIATION: return createWhatIfVariation();
      case DescartesQLPackage.FILTERING_CLAUSE: return createFilteringClause();
      case DescartesQLPackage.FILTERING_STRATEGY: return createFilteringStrategy();
      case DescartesQLPackage.FILTERING_RULE: return createFilteringRule();
      case DescartesQLPackage.WHAT_IF_VARIATION_CLAUSE: return createWhatIfVariationClause();
      case DescartesQLPackage.WHAT_IF_VALUE_VARIATION_CLAUSE: return createWhatIfValueVariationClause();
      case DescartesQLPackage.MULTIPLE_VARIATION_INSTRUCTION: return createMultipleVariationInstruction();
      case DescartesQLPackage.VARIATION_INSTRUCTION: return createVariationInstruction();
      case DescartesQLPackage.MULTIPLE_ARITHMETIC_CLAUSE: return createMultipleArithmeticClause();
      case DescartesQLPackage.ARITHMETIC_CLAUSE: return createArithmeticClause();
      case DescartesQLPackage.VARIABLE_VALUE: return createVariableValue();
      default:
        throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object createFromString(EDataType eDataType, String initialValue)
  {
    switch (eDataType.getClassifierID())
    {
      case DescartesQLPackage.COMPARATOR:
        return createComparatorFromString(eDataType, initialValue);
      case DescartesQLPackage.CURRENCY:
        return createCurrencyFromString(eDataType, initialValue);
      case DescartesQLPackage.FILTER_CONJUNCTION:
        return createFilterConjunctionFromString(eDataType, initialValue);
      case DescartesQLPackage.FILTER_CONDITION_TYPE:
        return createFilterConditionTypeFromString(eDataType, initialValue);
      case DescartesQLPackage.OBSERVE_RELATIVE_DIRECTION_TYPE:
        return createObserveRelativeDirectionTypeFromString(eDataType, initialValue);
      case DescartesQLPackage.RELATIVE_TIME_SIGN_TYPE:
        return createRelativeTimeSignTypeFromString(eDataType, initialValue);
      case DescartesQLPackage.TIME_MODIFIER_TYPE:
        return createTimeModifierTypeFromString(eDataType, initialValue);
      case DescartesQLPackage.STATISTICAL_AGGREGATE_TYPE:
        return createStatisticalAggregateTypeFromString(eDataType, initialValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String convertToString(EDataType eDataType, Object instanceValue)
  {
    switch (eDataType.getClassifierID())
    {
      case DescartesQLPackage.COMPARATOR:
        return convertComparatorToString(eDataType, instanceValue);
      case DescartesQLPackage.CURRENCY:
        return convertCurrencyToString(eDataType, instanceValue);
      case DescartesQLPackage.FILTER_CONJUNCTION:
        return convertFilterConjunctionToString(eDataType, instanceValue);
      case DescartesQLPackage.FILTER_CONDITION_TYPE:
        return convertFilterConditionTypeToString(eDataType, instanceValue);
      case DescartesQLPackage.OBSERVE_RELATIVE_DIRECTION_TYPE:
        return convertObserveRelativeDirectionTypeToString(eDataType, instanceValue);
      case DescartesQLPackage.RELATIVE_TIME_SIGN_TYPE:
        return convertRelativeTimeSignTypeToString(eDataType, instanceValue);
      case DescartesQLPackage.TIME_MODIFIER_TYPE:
        return convertTimeModifierTypeToString(eDataType, instanceValue);
      case DescartesQLPackage.STATISTICAL_AGGREGATE_TYPE:
        return convertStatisticalAggregateTypeToString(eDataType, instanceValue);
      default:
        throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier");
    }
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DescartesQL createDescartesQL()
  {
    DescartesQLImpl descartesQL = new DescartesQLImpl();
    return descartesQL;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Goal createGoal()
  {
    GoalImpl goal = new GoalImpl();
    return goal;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SlaQuery createSlaQuery()
  {
    SlaQueryImpl slaQuery = new SlaQueryImpl();
    return slaQuery;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SloQuery createSloQuery()
  {
    SloQueryImpl sloQuery = new SloQueryImpl();
    return sloQuery;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Sla createSla()
  {
    SlaImpl sla = new SlaImpl();
    return sla;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Slo createSlo()
  {
    SloImpl slo = new SloImpl();
    return slo;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public WeightedSlo createWeightedSlo()
  {
    WeightedSloImpl weightedSlo = new WeightedSloImpl();
    return weightedSlo;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Fuzziness createFuzziness()
  {
    FuzzinessImpl fuzziness = new FuzzinessImpl();
    return fuzziness;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Penalty createPenalty()
  {
    PenaltyImpl penalty = new PenaltyImpl();
    return penalty;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Violation createViolation()
  {
    ViolationImpl violation = new ViolationImpl();
    return violation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ModelStructureQuery createModelStructureQuery()
  {
    ModelStructureQueryImpl modelStructureQuery = new ModelStructureQueryImpl();
    return modelStructureQuery;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PerformanceMetricsQuery createPerformanceMetricsQuery()
  {
    PerformanceMetricsQueryImpl performanceMetricsQuery = new PerformanceMetricsQueryImpl();
    return performanceMetricsQuery;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public PerformanceIssueQuery createPerformanceIssueQuery()
  {
    PerformanceIssueQueryImpl performanceIssueQuery = new PerformanceIssueQueryImpl();
    return performanceIssueQuery;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ConnectorCapabilityQuery createConnectorCapabilityQuery()
  {
    ConnectorCapabilityQueryImpl connectorCapabilityQuery = new ConnectorCapabilityQueryImpl();
    return connectorCapabilityQuery;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ListQuery createListQuery()
  {
    ListQueryImpl listQuery = new ListQueryImpl();
    return listQuery;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public GetQuery createGetQuery()
  {
    GetQueryImpl getQuery = new GetQueryImpl();
    return getQuery;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public GetConstraintsQuery createGetConstraintsQuery()
  {
    GetConstraintsQueryImpl getConstraintsQuery = new GetConstraintsQueryImpl();
    return getConstraintsQuery;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public GetExplorationStrategiesQuery createGetExplorationStrategiesQuery()
  {
    GetExplorationStrategiesQueryImpl getExplorationStrategiesQuery = new GetExplorationStrategiesQueryImpl();
    return getExplorationStrategiesQuery;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public GetTimeUnitsQuery createGetTimeUnitsQuery()
  {
    GetTimeUnitsQueryImpl getTimeUnitsQuery = new GetTimeUnitsQueryImpl();
    return getTimeUnitsQuery;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ListDoFQuery createListDoFQuery()
  {
    ListDoFQueryImpl listDoFQuery = new ListDoFQueryImpl();
    return listDoFQuery;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ListEntitiesQuery createListEntitiesQuery()
  {
    ListEntitiesQueryImpl listEntitiesQuery = new ListEntitiesQueryImpl();
    return listEntitiesQuery;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ListMetricsQuery createListMetricsQuery()
  {
    ListMetricsQueryImpl listMetricsQuery = new ListMetricsQueryImpl();
    return listMetricsQuery;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SelectQuery createSelectQuery()
  {
    SelectQueryImpl selectQuery = new SelectQueryImpl();
    return selectQuery;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MetricReferenceClauses createMetricReferenceClauses()
  {
    MetricReferenceClausesImpl metricReferenceClauses = new MetricReferenceClausesImpl();
    return metricReferenceClauses;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MetricClauseType createMetricClauseType()
  {
    MetricClauseTypeImpl metricClauseType = new MetricClauseTypeImpl();
    return metricClauseType;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DetectQuery createDetectQuery()
  {
    DetectQueryImpl detectQuery = new DetectQueryImpl();
    return detectQuery;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DetectBottlenecksQuery createDetectBottlenecksQuery()
  {
    DetectBottlenecksQueryImpl detectBottlenecksQuery = new DetectBottlenecksQueryImpl();
    return detectBottlenecksQuery;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ConstraintClause createConstraintClause()
  {
    ConstraintClauseImpl constraintClause = new ConstraintClauseImpl();
    return constraintClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DoFClause createDoFClause()
  {
    DoFClauseImpl doFClause = new DoFClauseImpl();
    return doFClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ExplorationStrategyClause createExplorationStrategyClause()
  {
    ExplorationStrategyClauseImpl explorationStrategyClause = new ExplorationStrategyClauseImpl();
    return explorationStrategyClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ConfigurationPropertiesClause createConfigurationPropertiesClause()
  {
    ConfigurationPropertiesClauseImpl configurationPropertiesClause = new ConfigurationPropertiesClauseImpl();
    return configurationPropertiesClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ConfigurationPropertyClause createConfigurationPropertyClause()
  {
    ConfigurationPropertyClauseImpl configurationPropertyClause = new ConfigurationPropertyClauseImpl();
    return configurationPropertyClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DoFVariationClause createDoFVariationClause()
  {
    DoFVariationClauseImpl doFVariationClause = new DoFVariationClauseImpl();
    return doFVariationClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ValueVariationClause createValueVariationClause()
  {
    ValueVariationClauseImpl valueVariationClause = new ValueVariationClauseImpl();
    return valueVariationClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public IntervalVariationClause createIntervalVariationClause()
  {
    IntervalVariationClauseImpl intervalVariationClause = new IntervalVariationClauseImpl();
    return intervalVariationClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VaryingClause createVaryingClause()
  {
    VaryingClauseImpl varyingClause = new VaryingClauseImpl();
    return varyingClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DoFReference createDoFReference()
  {
    DoFReferenceImpl doFReference = new DoFReferenceImpl();
    return doFReference;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MetricClause createMetricClause()
  {
    MetricClauseImpl metricClause = new MetricClauseImpl();
    return metricClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AggregateMetricClause createAggregateMetricClause()
  {
    AggregateMetricClauseImpl aggregateMetricClause = new AggregateMetricClauseImpl();
    return aggregateMetricClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MetricClauses createMetricClauses()
  {
    MetricClausesImpl metricClauses = new MetricClausesImpl();
    return metricClauses;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MetricStarClause createMetricStarClause()
  {
    MetricStarClauseImpl metricStarClause = new MetricStarClauseImpl();
    return metricStarClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MetricReference createMetricReference()
  {
    MetricReferenceImpl metricReference = new MetricReferenceImpl();
    return metricReference;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NavigationClause createNavigationClause()
  {
    NavigationClauseImpl navigationClause = new NavigationClauseImpl();
    return navigationClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ChildrenClause createChildrenClause()
  {
    ChildrenClauseImpl childrenClause = new ChildrenClauseImpl();
    return childrenClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ParentClause createParentClause()
  {
    ParentClauseImpl parentClause = new ParentClauseImpl();
    return parentClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FindClause createFindClause()
  {
    FindClauseImpl findClause = new FindClauseImpl();
    return findClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ForClause createForClause()
  {
    ForClauseImpl forClause = new ForClauseImpl();
    return forClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EntityReferenceClause createEntityReferenceClause()
  {
    EntityReferenceClauseImpl entityReferenceClause = new EntityReferenceClauseImpl();
    return entityReferenceClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EntityReference createEntityReference()
  {
    EntityReferenceImpl entityReference = new EntityReferenceImpl();
    return entityReference;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AliasClause createAliasClause()
  {
    AliasClauseImpl aliasClause = new AliasClauseImpl();
    return aliasClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public UsingClause createUsingClause()
  {
    UsingClauseImpl usingClause = new UsingClauseImpl();
    return usingClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public WithClause createWithClause()
  {
    WithClauseImpl withClause = new WithClauseImpl();
    return withClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ModelReferenceClause createModelReferenceClause()
  {
    ModelReferenceClauseImpl modelReferenceClause = new ModelReferenceClauseImpl();
    return modelReferenceClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ModelFamily createModelFamily()
  {
    ModelFamilyImpl modelFamily = new ModelFamilyImpl();
    return modelFamily;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ModelLocation createModelLocation()
  {
    ModelLocationImpl modelLocation = new ModelLocationImpl();
    return modelLocation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FilterClause createFilterClause()
  {
    FilterClauseImpl filterClause = new FilterClauseImpl();
    return filterClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FilterConditionClause createFilterConditionClause()
  {
    FilterConditionClauseImpl filterConditionClause = new FilterConditionClauseImpl();
    return filterConditionClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FilterConditionValue createFilterConditionValue()
  {
    FilterConditionValueImpl filterConditionValue = new FilterConditionValueImpl();
    return filterConditionValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ObserveClause createObserveClause()
  {
    ObserveClauseImpl observeClause = new ObserveClauseImpl();
    return observeClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ObservationClause createObservationClause()
  {
    ObservationClauseImpl observationClause = new ObservationClauseImpl();
    return observationClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public SampleClause createSampleClause()
  {
    SampleClauseImpl sampleClause = new SampleClauseImpl();
    return sampleClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ConnectorTimeUnitClause createConnectorTimeUnitClause()
  {
    ConnectorTimeUnitClauseImpl connectorTimeUnitClause = new ConnectorTimeUnitClauseImpl();
    return connectorTimeUnitClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ConnectorInstanceReferenceClause createConnectorInstanceReferenceClause()
  {
    ConnectorInstanceReferenceClauseImpl connectorInstanceReferenceClause = new ConnectorInstanceReferenceClauseImpl();
    return connectorInstanceReferenceClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ObserveRelativeClause createObserveRelativeClause()
  {
    ObserveRelativeClauseImpl observeRelativeClause = new ObserveRelativeClauseImpl();
    return observeRelativeClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ObserveBetweenClause createObserveBetweenClause()
  {
    ObserveBetweenClauseImpl observeBetweenClause = new ObserveBetweenClauseImpl();
    return observeBetweenClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RelativeTimeWithSignClause createRelativeTimeWithSignClause()
  {
    RelativeTimeWithSignClauseImpl relativeTimeWithSignClause = new RelativeTimeWithSignClauseImpl();
    return relativeTimeWithSignClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public BetweenTimeClause createBetweenTimeClause()
  {
    BetweenTimeClauseImpl betweenTimeClause = new BetweenTimeClauseImpl();
    return betweenTimeClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public TimeClause createTimeClause()
  {
    TimeClauseImpl timeClause = new TimeClauseImpl();
    return timeClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AbsoluteTimeClause createAbsoluteTimeClause()
  {
    AbsoluteTimeClauseImpl absoluteTimeClause = new AbsoluteTimeClauseImpl();
    return absoluteTimeClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RelativeTimeClause createRelativeTimeClause()
  {
    RelativeTimeClauseImpl relativeTimeClause = new RelativeTimeClauseImpl();
    return relativeTimeClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RelativeTimeDurationClause createRelativeTimeDurationClause()
  {
    RelativeTimeDurationClauseImpl relativeTimeDurationClause = new RelativeTimeDurationClauseImpl();
    return relativeTimeDurationClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public WhatIfQuery createWhatIfQuery()
  {
    WhatIfQueryImpl whatIfQuery = new WhatIfQueryImpl();
    return whatIfQuery;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public WhatIfVariation createWhatIfVariation()
  {
    WhatIfVariationImpl whatIfVariation = new WhatIfVariationImpl();
    return whatIfVariation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FilteringClause createFilteringClause()
  {
    FilteringClauseImpl filteringClause = new FilteringClauseImpl();
    return filteringClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FilteringStrategy createFilteringStrategy()
  {
    FilteringStrategyImpl filteringStrategy = new FilteringStrategyImpl();
    return filteringStrategy;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FilteringRule createFilteringRule()
  {
    FilteringRuleImpl filteringRule = new FilteringRuleImpl();
    return filteringRule;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public WhatIfVariationClause createWhatIfVariationClause()
  {
    WhatIfVariationClauseImpl whatIfVariationClause = new WhatIfVariationClauseImpl();
    return whatIfVariationClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public WhatIfValueVariationClause createWhatIfValueVariationClause()
  {
    WhatIfValueVariationClauseImpl whatIfValueVariationClause = new WhatIfValueVariationClauseImpl();
    return whatIfValueVariationClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MultipleVariationInstruction createMultipleVariationInstruction()
  {
    MultipleVariationInstructionImpl multipleVariationInstruction = new MultipleVariationInstructionImpl();
    return multipleVariationInstruction;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VariationInstruction createVariationInstruction()
  {
    VariationInstructionImpl variationInstruction = new VariationInstructionImpl();
    return variationInstruction;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MultipleArithmeticClause createMultipleArithmeticClause()
  {
    MultipleArithmeticClauseImpl multipleArithmeticClause = new MultipleArithmeticClauseImpl();
    return multipleArithmeticClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ArithmeticClause createArithmeticClause()
  {
    ArithmeticClauseImpl arithmeticClause = new ArithmeticClauseImpl();
    return arithmeticClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public VariableValue createVariableValue()
  {
    VariableValueImpl variableValue = new VariableValueImpl();
    return variableValue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Comparator createComparatorFromString(EDataType eDataType, String initialValue)
  {
    Comparator result = Comparator.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertComparatorToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Currency createCurrencyFromString(EDataType eDataType, String initialValue)
  {
    Currency result = Currency.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertCurrencyToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FilterConjunction createFilterConjunctionFromString(EDataType eDataType, String initialValue)
  {
    FilterConjunction result = FilterConjunction.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertFilterConjunctionToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public FilterConditionType createFilterConditionTypeFromString(EDataType eDataType, String initialValue)
  {
    FilterConditionType result = FilterConditionType.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertFilterConditionTypeToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ObserveRelativeDirectionType createObserveRelativeDirectionTypeFromString(EDataType eDataType, String initialValue)
  {
    ObserveRelativeDirectionType result = ObserveRelativeDirectionType.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertObserveRelativeDirectionTypeToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public RelativeTimeSignType createRelativeTimeSignTypeFromString(EDataType eDataType, String initialValue)
  {
    RelativeTimeSignType result = RelativeTimeSignType.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertRelativeTimeSignTypeToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public TimeModifierType createTimeModifierTypeFromString(EDataType eDataType, String initialValue)
  {
    TimeModifierType result = TimeModifierType.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertTimeModifierTypeToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public StatisticalAggregateType createStatisticalAggregateTypeFromString(EDataType eDataType, String initialValue)
  {
    StatisticalAggregateType result = StatisticalAggregateType.get(initialValue);
    if (result == null) throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'");
    return result;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String convertStatisticalAggregateTypeToString(EDataType eDataType, Object instanceValue)
  {
    return instanceValue == null ? null : instanceValue.toString();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public DescartesQLPackage getDescartesQLPackage()
  {
    return (DescartesQLPackage)getEPackage();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @deprecated
   * @generated
   */
  @Deprecated
  public static DescartesQLPackage getPackage()
  {
    return DescartesQLPackage.eINSTANCE;
  }

} //DescartesQLFactoryImpl
