/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL.impl;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import tools.descartes.dql.lang.descartesQL.DescartesQLPackage;
import tools.descartes.dql.lang.descartesQL.DoFVariationClause;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Do FVariation Clause</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.DoFVariationClauseImpl#getMode1 <em>Mode1</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.DoFVariationClauseImpl#getVariation <em>Variation</em>}</li>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.DoFVariationClauseImpl#getMode2 <em>Mode2</em>}</li>
 * </ul>
 *
 * @generated
 */
public class DoFVariationClauseImpl extends MinimalEObjectImpl.Container implements DoFVariationClause
{
  /**
   * The default value of the '{@link #getMode1() <em>Mode1</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMode1()
   * @generated
   * @ordered
   */
  protected static final String MODE1_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getMode1() <em>Mode1</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMode1()
   * @generated
   * @ordered
   */
  protected String mode1 = MODE1_EDEFAULT;

  /**
   * The cached value of the '{@link #getVariation() <em>Variation</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getVariation()
   * @generated
   * @ordered
   */
  protected EObject variation;

  /**
   * The default value of the '{@link #getMode2() <em>Mode2</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMode2()
   * @generated
   * @ordered
   */
  protected static final String MODE2_EDEFAULT = null;

  /**
   * The cached value of the '{@link #getMode2() <em>Mode2</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMode2()
   * @generated
   * @ordered
   */
  protected String mode2 = MODE2_EDEFAULT;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected DoFVariationClauseImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return DescartesQLPackage.Literals.DO_FVARIATION_CLAUSE;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getMode1()
  {
    return mode1;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMode1(String newMode1)
  {
    String oldMode1 = mode1;
    mode1 = newMode1;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.DO_FVARIATION_CLAUSE__MODE1, oldMode1, mode1));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EObject getVariation()
  {
    return variation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetVariation(EObject newVariation, NotificationChain msgs)
  {
    EObject oldVariation = variation;
    variation = newVariation;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, DescartesQLPackage.DO_FVARIATION_CLAUSE__VARIATION, oldVariation, newVariation);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setVariation(EObject newVariation)
  {
    if (newVariation != variation)
    {
      NotificationChain msgs = null;
      if (variation != null)
        msgs = ((InternalEObject)variation).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.DO_FVARIATION_CLAUSE__VARIATION, null, msgs);
      if (newVariation != null)
        msgs = ((InternalEObject)newVariation).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - DescartesQLPackage.DO_FVARIATION_CLAUSE__VARIATION, null, msgs);
      msgs = basicSetVariation(newVariation, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.DO_FVARIATION_CLAUSE__VARIATION, newVariation, newVariation));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getMode2()
  {
    return mode2;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setMode2(String newMode2)
  {
    String oldMode2 = mode2;
    mode2 = newMode2;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, DescartesQLPackage.DO_FVARIATION_CLAUSE__MODE2, oldMode2, mode2));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case DescartesQLPackage.DO_FVARIATION_CLAUSE__VARIATION:
        return basicSetVariation(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case DescartesQLPackage.DO_FVARIATION_CLAUSE__MODE1:
        return getMode1();
      case DescartesQLPackage.DO_FVARIATION_CLAUSE__VARIATION:
        return getVariation();
      case DescartesQLPackage.DO_FVARIATION_CLAUSE__MODE2:
        return getMode2();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case DescartesQLPackage.DO_FVARIATION_CLAUSE__MODE1:
        setMode1((String)newValue);
        return;
      case DescartesQLPackage.DO_FVARIATION_CLAUSE__VARIATION:
        setVariation((EObject)newValue);
        return;
      case DescartesQLPackage.DO_FVARIATION_CLAUSE__MODE2:
        setMode2((String)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.DO_FVARIATION_CLAUSE__MODE1:
        setMode1(MODE1_EDEFAULT);
        return;
      case DescartesQLPackage.DO_FVARIATION_CLAUSE__VARIATION:
        setVariation((EObject)null);
        return;
      case DescartesQLPackage.DO_FVARIATION_CLAUSE__MODE2:
        setMode2(MODE2_EDEFAULT);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.DO_FVARIATION_CLAUSE__MODE1:
        return MODE1_EDEFAULT == null ? mode1 != null : !MODE1_EDEFAULT.equals(mode1);
      case DescartesQLPackage.DO_FVARIATION_CLAUSE__VARIATION:
        return variation != null;
      case DescartesQLPackage.DO_FVARIATION_CLAUSE__MODE2:
        return MODE2_EDEFAULT == null ? mode2 != null : !MODE2_EDEFAULT.equals(mode2);
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (mode1: ");
    result.append(mode1);
    result.append(", mode2: ");
    result.append(mode2);
    result.append(')');
    return result.toString();
  }

} //DoFVariationClauseImpl
