/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 * 
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 * 
 * Project Info:   http://descartes.tools/dql
 * 
 * All rights reserved. This software is made available under the terms of the 
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 * 
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org 
 * 
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.dql.lang.descartesQL.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.MinimalEObjectImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import tools.descartes.dql.lang.descartesQL.DescartesQLPackage;
import tools.descartes.dql.lang.descartesQL.WhatIfVariation;
import tools.descartes.dql.lang.descartesQL.WhatIfVariationClause;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>What If Variation</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * </p>
 * <ul>
 *   <li>{@link tools.descartes.dql.lang.descartesQL.impl.WhatIfVariationImpl#getWhatIfVariationClause <em>What If Variation Clause</em>}</li>
 * </ul>
 *
 * @generated
 */
public class WhatIfVariationImpl extends MinimalEObjectImpl.Container implements WhatIfVariation
{
  /**
   * The cached value of the '{@link #getWhatIfVariationClause() <em>What If Variation Clause</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getWhatIfVariationClause()
   * @generated
   * @ordered
   */
  protected EList<WhatIfVariationClause> whatIfVariationClause;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected WhatIfVariationImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return DescartesQLPackage.Literals.WHAT_IF_VARIATION;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<WhatIfVariationClause> getWhatIfVariationClause()
  {
    if (whatIfVariationClause == null)
    {
      whatIfVariationClause = new EObjectContainmentEList<WhatIfVariationClause>(WhatIfVariationClause.class, this, DescartesQLPackage.WHAT_IF_VARIATION__WHAT_IF_VARIATION_CLAUSE);
    }
    return whatIfVariationClause;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case DescartesQLPackage.WHAT_IF_VARIATION__WHAT_IF_VARIATION_CLAUSE:
        return ((InternalEList<?>)getWhatIfVariationClause()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case DescartesQLPackage.WHAT_IF_VARIATION__WHAT_IF_VARIATION_CLAUSE:
        return getWhatIfVariationClause();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case DescartesQLPackage.WHAT_IF_VARIATION__WHAT_IF_VARIATION_CLAUSE:
        getWhatIfVariationClause().clear();
        getWhatIfVariationClause().addAll((Collection<? extends WhatIfVariationClause>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.WHAT_IF_VARIATION__WHAT_IF_VARIATION_CLAUSE:
        getWhatIfVariationClause().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case DescartesQLPackage.WHAT_IF_VARIATION__WHAT_IF_VARIATION_CLAUSE:
        return whatIfVariationClause != null && !whatIfVariationClause.isEmpty();
    }
    return super.eIsSet(featureID);
  }

} //WhatIfVariationImpl
