/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
/**
 */
package tools.descartes.dql.models.repository.impl;

import java.util.Collection;
import java.util.Date;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import tools.descartes.dql.models.repository.ObservableImpact;
import tools.descartes.dql.models.repository.Observation;
import tools.descartes.dql.models.repository.ObservationRepository;
import tools.descartes.dql.models.repository.RepositoryPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Observation Repository</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link tools.descartes.dql.models.repository.impl.ObservationRepositoryImpl#getImpacts <em>Impacts</em>}</li>
 *   <li>{@link tools.descartes.dql.models.repository.impl.ObservationRepositoryImpl#getObservations <em>Observations</em>}</li>
 *   <li>{@link tools.descartes.dql.models.repository.impl.ObservationRepositoryImpl#getStartTimestamp <em>Start Timestamp</em>}</li>
 *   <li>{@link tools.descartes.dql.models.repository.impl.ObservationRepositoryImpl#getEndTimestamp <em>End Timestamp</em>}</li>
 *   <li>{@link tools.descartes.dql.models.repository.impl.ObservationRepositoryImpl#getLatestObservation <em>Latest Observation</em>}</li>
 *   <li>{@link tools.descartes.dql.models.repository.impl.ObservationRepositoryImpl#getLatestImpact <em>Latest Impact</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ObservationRepositoryImpl extends IdentfierImpl implements ObservationRepository {
	/**
	 * The cached value of the '{@link #getImpacts() <em>Impacts</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getImpacts()
	 * @generated
	 * @ordered
	 */
	protected EList<ObservableImpact> impacts;

	/**
	 * The cached value of the '{@link #getObservations() <em>Observations</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getObservations()
	 * @generated
	 * @ordered
	 */
	protected EList<Observation> observations;

	/**
	 * The default value of the '{@link #getStartTimestamp() <em>Start Timestamp</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStartTimestamp()
	 * @generated
	 * @ordered
	 */
	protected static final Date START_TIMESTAMP_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getStartTimestamp() <em>Start Timestamp</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getStartTimestamp()
	 * @generated
	 * @ordered
	 */
	protected Date startTimestamp = START_TIMESTAMP_EDEFAULT;

	/**
	 * The default value of the '{@link #getEndTimestamp() <em>End Timestamp</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEndTimestamp()
	 * @generated
	 * @ordered
	 */
	protected static final Date END_TIMESTAMP_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getEndTimestamp() <em>End Timestamp</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getEndTimestamp()
	 * @generated
	 * @ordered
	 */
	protected Date endTimestamp = END_TIMESTAMP_EDEFAULT;

	/**
	 * The cached value of the '{@link #getLatestObservation() <em>Latest Observation</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLatestObservation()
	 * @generated
	 * @ordered
	 */
	protected Observation latestObservation;

	/**
	 * The cached value of the '{@link #getLatestImpact() <em>Latest Impact</em>}' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getLatestImpact()
	 * @generated
	 * @ordered
	 */
	protected ObservableImpact latestImpact;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ObservationRepositoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return RepositoryPackage.Literals.OBSERVATION_REPOSITORY;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<ObservableImpact> getImpacts() {
		if (impacts == null) {
			impacts = new EObjectContainmentEList<ObservableImpact>(ObservableImpact.class, this, RepositoryPackage.OBSERVATION_REPOSITORY__IMPACTS);
		}
		return impacts;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Observation> getObservations() {
		if (observations == null) {
			observations = new EObjectContainmentEList<Observation>(Observation.class, this, RepositoryPackage.OBSERVATION_REPOSITORY__OBSERVATIONS);
		}
		return observations;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Date getStartTimestamp() {
		return startTimestamp;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setStartTimestamp(Date newStartTimestamp) {
		Date oldStartTimestamp = startTimestamp;
		startTimestamp = newStartTimestamp;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.OBSERVATION_REPOSITORY__START_TIMESTAMP, oldStartTimestamp, startTimestamp));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Date getEndTimestamp() {
		return endTimestamp;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setEndTimestamp(Date newEndTimestamp) {
		Date oldEndTimestamp = endTimestamp;
		endTimestamp = newEndTimestamp;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.OBSERVATION_REPOSITORY__END_TIMESTAMP, oldEndTimestamp, endTimestamp));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Observation getLatestObservation() {
		if (latestObservation != null && latestObservation.eIsProxy()) {
			InternalEObject oldLatestObservation = (InternalEObject)latestObservation;
			latestObservation = (Observation)eResolveProxy(oldLatestObservation);
			if (latestObservation != oldLatestObservation) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RepositoryPackage.OBSERVATION_REPOSITORY__LATEST_OBSERVATION, oldLatestObservation, latestObservation));
			}
		}
		return latestObservation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Observation basicGetLatestObservation() {
		return latestObservation;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLatestObservation(Observation newLatestObservation) {
		Observation oldLatestObservation = latestObservation;
		latestObservation = newLatestObservation;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.OBSERVATION_REPOSITORY__LATEST_OBSERVATION, oldLatestObservation, latestObservation));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ObservableImpact getLatestImpact() {
		if (latestImpact != null && latestImpact.eIsProxy()) {
			InternalEObject oldLatestImpact = (InternalEObject)latestImpact;
			latestImpact = (ObservableImpact)eResolveProxy(oldLatestImpact);
			if (latestImpact != oldLatestImpact) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, RepositoryPackage.OBSERVATION_REPOSITORY__LATEST_IMPACT, oldLatestImpact, latestImpact));
			}
		}
		return latestImpact;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ObservableImpact basicGetLatestImpact() {
		return latestImpact;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setLatestImpact(ObservableImpact newLatestImpact) {
		ObservableImpact oldLatestImpact = latestImpact;
		latestImpact = newLatestImpact;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, RepositoryPackage.OBSERVATION_REPOSITORY__LATEST_IMPACT, oldLatestImpact, latestImpact));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case RepositoryPackage.OBSERVATION_REPOSITORY__IMPACTS:
				return ((InternalEList<?>)getImpacts()).basicRemove(otherEnd, msgs);
			case RepositoryPackage.OBSERVATION_REPOSITORY__OBSERVATIONS:
				return ((InternalEList<?>)getObservations()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case RepositoryPackage.OBSERVATION_REPOSITORY__IMPACTS:
				return getImpacts();
			case RepositoryPackage.OBSERVATION_REPOSITORY__OBSERVATIONS:
				return getObservations();
			case RepositoryPackage.OBSERVATION_REPOSITORY__START_TIMESTAMP:
				return getStartTimestamp();
			case RepositoryPackage.OBSERVATION_REPOSITORY__END_TIMESTAMP:
				return getEndTimestamp();
			case RepositoryPackage.OBSERVATION_REPOSITORY__LATEST_OBSERVATION:
				if (resolve) return getLatestObservation();
				return basicGetLatestObservation();
			case RepositoryPackage.OBSERVATION_REPOSITORY__LATEST_IMPACT:
				if (resolve) return getLatestImpact();
				return basicGetLatestImpact();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case RepositoryPackage.OBSERVATION_REPOSITORY__IMPACTS:
				getImpacts().clear();
				getImpacts().addAll((Collection<? extends ObservableImpact>)newValue);
				return;
			case RepositoryPackage.OBSERVATION_REPOSITORY__OBSERVATIONS:
				getObservations().clear();
				getObservations().addAll((Collection<? extends Observation>)newValue);
				return;
			case RepositoryPackage.OBSERVATION_REPOSITORY__START_TIMESTAMP:
				setStartTimestamp((Date)newValue);
				return;
			case RepositoryPackage.OBSERVATION_REPOSITORY__END_TIMESTAMP:
				setEndTimestamp((Date)newValue);
				return;
			case RepositoryPackage.OBSERVATION_REPOSITORY__LATEST_OBSERVATION:
				setLatestObservation((Observation)newValue);
				return;
			case RepositoryPackage.OBSERVATION_REPOSITORY__LATEST_IMPACT:
				setLatestImpact((ObservableImpact)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case RepositoryPackage.OBSERVATION_REPOSITORY__IMPACTS:
				getImpacts().clear();
				return;
			case RepositoryPackage.OBSERVATION_REPOSITORY__OBSERVATIONS:
				getObservations().clear();
				return;
			case RepositoryPackage.OBSERVATION_REPOSITORY__START_TIMESTAMP:
				setStartTimestamp(START_TIMESTAMP_EDEFAULT);
				return;
			case RepositoryPackage.OBSERVATION_REPOSITORY__END_TIMESTAMP:
				setEndTimestamp(END_TIMESTAMP_EDEFAULT);
				return;
			case RepositoryPackage.OBSERVATION_REPOSITORY__LATEST_OBSERVATION:
				setLatestObservation((Observation)null);
				return;
			case RepositoryPackage.OBSERVATION_REPOSITORY__LATEST_IMPACT:
				setLatestImpact((ObservableImpact)null);
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case RepositoryPackage.OBSERVATION_REPOSITORY__IMPACTS:
				return impacts != null && !impacts.isEmpty();
			case RepositoryPackage.OBSERVATION_REPOSITORY__OBSERVATIONS:
				return observations != null && !observations.isEmpty();
			case RepositoryPackage.OBSERVATION_REPOSITORY__START_TIMESTAMP:
				return START_TIMESTAMP_EDEFAULT == null ? startTimestamp != null : !START_TIMESTAMP_EDEFAULT.equals(startTimestamp);
			case RepositoryPackage.OBSERVATION_REPOSITORY__END_TIMESTAMP:
				return END_TIMESTAMP_EDEFAULT == null ? endTimestamp != null : !END_TIMESTAMP_EDEFAULT.equals(endTimestamp);
			case RepositoryPackage.OBSERVATION_REPOSITORY__LATEST_OBSERVATION:
				return latestObservation != null;
			case RepositoryPackage.OBSERVATION_REPOSITORY__LATEST_IMPACT:
				return latestImpact != null;
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (startTimestamp: ");
		result.append(startTimestamp);
		result.append(", endTimestamp: ");
		result.append(endTimestamp);
		result.append(')');
		return result.toString();
	}

} //ObservationRepositoryImpl
