/**
 * ==============================================
 *  DQL : Descartes Query Language
 * ==============================================
 *
 * (c) Copyright 2014-2016, by Juergen Walter, Fabian Gorsler, Fabian Brosig and other contributors.
 *
 * Project Info:   http://descartes.tools/dql
 *
 * All rights reserved. This software is made available under the terms of the
 * Eclipse Public License (EPL) v1.0 as published by the Eclipse Foundation
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * This software is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE. See the Eclipse Public License (EPL)
 * for more details.
 *
 * You should have received a copy of the Eclipse Public License (EPL)
 * along with this software; if not visit http://www.eclipse.org or write to
 * Eclipse Foundation, Inc., 308 SW First Avenue, Suite 110, Portland, 97204 USA
 * Email: license (at) eclipse.org
 *
 * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
 * in the United States and other countries.]
 */
package tools.descartes.pavo.result;

/**
 * class for a simple String as result
 * 
 * @author Maximilian König <max.c.koenig@t-online.de>
 * @since 2016
 */
public class StringResultPavo extends AbstractQuantitativeResult {

	String value;

	/**
	 * @param queryableElementN
	 *            current queryable element
	 * @param metricN
	 *            current metric
	 * @param statisticTypeN
	 *            current StatisticType
	 * @param valueN
	 *            the String value to be shown by pavo
	 */
	public StringResultPavo(String queryableElementN, String metricN, String description, String statisticTypeN,
			String valueN) {
		super(queryableElementN, metricN, description, statisticTypeN, null, null, null);
		value = valueN;
	}

	/**
	 * @return the value
	 */
	public String getValue() {
		return value;
	}

	/**
	 * @param value
	 *            the value to set
	 */
	public void setValue(String value) {
		this.value = value;
	}

	public String getName() {
		return this.getQueryableElement() + "." + this.getStatisticType();
	}

}